{ 䠩 ᮢ ResFile  *.bmp ⥪饩 ४ਨ,
 ᯨ᮪  室  䠩 filelist.txt}
uses Graph,Crt;
const VGAPath='d:\TP7\EGAVGA.BGI';
      FileList='filelist.txt';
      ResFile='attack.res';
const Width=32; Height=20;

const color: array [0..15] of byte=(0,4,2,6,1,5,3,7,8,12,10,14,9,13,11,15);
const MaxX=639; MaxY=479;
      Cx=MAxX div 2; Cy=MaxY div 2;

type bmpinfo=record
 h1,h2:char;
 size,reserved,offset,b,width,height:longint;
 plans,bpp:word;
end;
var Driver, Mode: integer;
    DriverF: file;
    List,Res:Text;
    DriverP: pointer;
    s:String;

procedure Wait;
var Ch:char;
begin
 Reset (Input);
 repeat until KeyPressed;
 Ch:=Readkey;
 if Ch=#0 then Readkey;
end;

procedure CloseMe;
begin
 if DriverP <> nil then begin
  FreeMem(DriverP, FileSize(DriverF));
  Close (DriverF);
 end;
 CloseGraph;
end;

procedure GraphError;
begin
 CloseMe;
 Writeln('Graphics error:', GraphErrorMsg(GraphResult));
 Writeln('Press any key to halt program...');
 Wait;
 Halt (GraphResult);
end;

procedure InitMe;
begin
 Assign(DriverF, VGAPath);
 Reset(DriverF, 1);
 GetMem(DriverP, FileSize(DriverF));
 BlockRead(DriverF, DriverP^, FileSize(DriverF));
 if RegisterBGIdriver(DriverP)<0 then GraphError;
 Driver:=VGA; Mode:=VGAHi;
 InitGraph(Driver, Mode,'');
 if GraphResult < 0 then GraphError;
end;

procedure ClearScreen;
begin
 setfillstyle (SolidFill, White);
 bar (0,0,MaxX,MaxY);
end;

procedure Window (x1,y1,x2,y2,Color,FillColor:integer);
begin
 SetColor (Color);
 SetFillStyle (1,FillColor);
 Bar (x1,y1,x2,y2);
 Rectangle (x1+2,y1+2,x2-2,y2-2);
 Rectangle (x1+4,y1+4,x2-4,y2-4);
 SetFillStyle (1,DARKGRAY);
 Bar (x1+8,y2+1,x2+8,y2+8);
 Bar (x2+1,y1+8,x2+8,y2);
end;

procedure Error (Code:integer; str:String);
begin
 Window (Cx-140,Cy-100,Cx+140,Cy-70,Black,Yellow);
 case Code of
  1: s:=' '+str+'  !';
  2: s:=' '+str+'  ଠ BMP-16';
  3: s:=' '+str+' ᯮ祭!';
 end;
 settextjustify (LeftText, TopText);
 SetTextStyle(DefaultFont, HorizDir, 1);
 outtextxy (Cx-136,Cy-92,s);
 Wait;
 Halt(Code);
end;

function Draw (x0,y0:integer; fname:string; transparent:boolean):integer;
var f:file of bmpinfo;
 bmpf:file of byte;
 res:integer;
 info:bmpinfo;
 x,y:integer;
 b,bh,bl:byte;
 nb,np:integer;
 tpcolor:byte;
 i,j:integer;
begin
 assign(f,fname);
 {$I-}
 reset (f);
 {$I+}
 res:=IoResult;
 if res <> 0 then Error (1,fname);
 read (f,info);
 close (f);
 if info.bpp<>4 then Error(2,fname);
 x:=x0;
 y:=y0+info.height;
 nb:=(info.width div 8)*4;
 if (info.width mod 8) <> 0 then nb:=nb+4;
 assign (bmpf,fname);
 reset (bmpf);
 seek (bmpf,info.offset);
 if transparent then begin
  read (bmpf,b);
  tpcolor:=b shr 4;
  seek (bmpf,info.offset);
 end
 else tpcolor:=17;
 for i:=1 to info.height do begin
  np:=0;
  for j:=1 to nb do begin
   read (bmpf,b);
   if np<info.width then begin
    bh:=b shr 4;
    if bh <> tpcolor then putpixel (x,y,color[bh]);
    inc (x);
    inc(np);
   end;
   if np<info.width then begin
    bl:=b and 15;
    if bl <> tpcolor then putpixel (x,y,color[bl]);
    inc(x);
    inc(np);
   end;
  end;
  x:=x0;
  dec(y);
 end;
 close (bmpf);
 Draw:=info.height;
end;

var i,j:word;
 b:char;
 r:integer;
begin
 InitMe;
 ClearScreen;
 assign (List,FileList);
 {$I-}
 reset (List);
 {$I+}
 if IoResult <> 0 then Error (1,FileList);
 assign (Res,ResFile);
 {$I-}
 rewrite (Res);
 {$I+}
 if IoResult <> 0 then Error (1,ResFile);
 settextjustify (CenterText,TopText);
 while not eof(List) do begin
  ReadLn (List,s);
  ClearScreen;
  Draw (0,0,s,True);
  for j:=1 to Height do
  for i:=1 to Width do begin
   b:=Chr(getpixel (i,j));
   write (Res,b);
  end;
  setcolor (black);
  outtextxy (Cx,MaxY-20,' '+s+' ');
  Wait;
 end;
 CloseMe;
 Close (Res);
 Close (List);
end.